console.log('functions.js');

// Ajouter X case/s supplémentaire/s autour du labyrinthe de base
function addBorders(arrayLaby){
  var tailleGrille = arrayLaby.length;

  arrayLaby.forEach(function(colonne){
      // console.log(colonne);

      for(var i = 0 ; i < tailleBordures ; i++){
        // Ajouter la première colonne
        colonne.unshift('.');

        // Ajouter la dernière colonne
        colonne.push('.');
      }
      // console.log(colonne);
    }
  );

  // Générer un tableau contenant autant de cases que la taille de la grille + bordure
  var ligne = '.'.repeat(tailleGrille + tailleBordures * 2).split('');
  // console.log(ligne);

  for(var i = 0 ; i < tailleBordures ; i++){
    // Ajouter les x première/s ligne/s
    arrayLaby.unshift(ligne);
    // Ajouter les x dernière/s ligne/s
    arrayLaby.push(ligne);
  }

  if(debug)
    console.log(arrayLaby);

  return arrayLaby;
}



// Vérifier les caractères fournis au labyrinthe
// Juste prévenir que les caractères non reconnus seront interprétés comme des cases vides
function checkLabyChars(labyCurrent) {
  var erreur = '';

  labyCurrent.forEach(
    function(ligne, indexLigne) {
      ligne.forEach(
        function(colonne, indexColonne) {
          // console.log(colonne);
          // console.log(allowedLabyChars.indexOf(colonne));
          if(allowedLabyChars.indexOf(colonne) < 0){
            erreur += '<p>Caractères non interprétés : "' + colonne + '", cf. ligne ' + indexLigne + ', colonne ' + indexColonne + '</p>';
          }
        }
      );
    }
  );

  if(erreur.length > 0){
    errorLabyHTML.append('<p>Le labyrinthe autorise les caractères "' + allowedLabyChars + '", les autres ne seront pas interprétés.</p>');
    errorLabyHTML.append(erreur);
  }
}



// Vérifier le fait que le labyrinthe soit carré (H == W), et qu'il ne dépasse pas 20 cases + les bordures
//    Note : même si ce n'est pas impactant pour ce programme ;)
function checkLabyLength(labyCurrent) {
  var tailleGrille = labyCurrent.length;
  if(debug) {
    console.log(tailleGrille);
    console.log(maxCases);
  }

  if(tailleGrille > maxCases) {
    errorLabyHTML.append('<p>Le labyrinthe ne doit pas dépasser 20 cases de hauteur.</p>');
  }

  labyCurrent.forEach(
    function(ligne, indexLigne) {
      if(debug)
        console.log(ligne.length);

      if(ligne.length > maxCases ){
        errorLabyHTML.append('<p>Le labyrinthe ne doit pas dépasser 20 cases de côté. Cf. ligne ' + indexLigne + '</p>');
      }

      if(ligne.length != tailleGrille){
        errorLabyHTML.append('<p>Le labyrinthe doit être carré. Cf. ligne ' + indexLigne + '</p>');
      }
    }
  );
}



// Vérifier la taille max (20), le fait que le labyrinthe soit carré, et les caractères fournis
function checkLabyIntegrity(labyCurrent) {
  // console.log(labyCurrent);
  errorLabyHTML.empty();

  checkLabyLength(labyCurrent);

  // console.log(errorLabyHTML.text());

  // Interrompre génération
  return errorLabyHTML.text().length > 0
    ? false
    : true;
}



// Gestion du ramassage
function checkPickup(arrayLaby) {
  // console.log(arrayLaby);
  // console.log(persoX);
  // console.log(persoY);

  var caseContent = arrayLaby[persoY][persoX];
  if(debug){
    console.log(caseContent);
    console.log('------');
  }

  switch(caseContent) {
    // gold
    case 'o':
      arrayLaby[persoY][persoX] = 'op';
      butinCurrent++;
      orHTML.html(countGoldLeft(arrayLaby));
    break;

    // star
    case '*':
      arrayLaby[persoY][persoX] = '*p';
      butinCurrent *= 2;

      if(countGoldLeft(arrayLaby) > 0){
        displayFailStar();
      }
    break;

    // ., op, xp
    // Nothing, gold already picked, star already picked
    default:
      // death
      clearInterval(idInterval);
      persoIcon = iconDeath;
      etatHTML.html('Vous êtes mort :3 / Mauvais ramassage');
    break;
  }

  // Mise à jour du labyrinthe
  return arrayLaby;
}



// Vérifie les conditions de victoire
function checkVictory(){
  if(butinCurrent == butinMax) {
    etatHTML.html('Victoire ! Yay !');
  }
  else {
    persoIcon = iconDeath;
    etatHTML.html('Vous n\'avez pas rammassé tout le butin. ' + butinCurrent + ' / ' + butinMax);
  }
}



function countGoldLeft(arrayLaby){
  var count = 0;

  arrayLaby.forEach(function(ligne){
    count += ligne.reduce(
      function(n, val) {
        return n + (val === 'o');
      }, 0);
  });

  if(debug)
    console.log(count);

  return count;
}



// Créer une variable js (tableaux lignes/colonnes) représentant le labyrinthe
//                    [
//    ....              ['.','.','.','.'],
//    o.*o              ['o','.','*','o'],
//    ....      =>      ['.','.','.','.'],
//    ....              ['.','.','.','.']
//                    ]
function createArrayLaby(texteLaby) {
  var arrayLaby = texteLaby.split('\n').map(
    function hey(ligne) {
      return ligne.split('');
    }
  );

  // Ajouter les bordures (au cas ou le perso dépasse)
  return addBorders(arrayLaby);
}



// Prévenir si un étoile à été ramassée avant la totalité de l'or
function displayFailStar(){
  failStarHTML.html(' Étoile ramassée alors qu\'il reste du butin :\'(');
}


// Extrait la première action de la liste, et met à jour la liste
function extractFirstAction(){
  // Extraire la première action
  var action = texteParcoursCurrent.slice(0, 1);
  if(debug)
    console.log(action);

  texteParcoursCurrent = texteParcoursCurrent.substring(1);
  if(debug)
    console.log(texteParcoursCurrent);

  return action;
}



// Teste si le perso est mort en sortant des bordures
function isDead(arrayLaby) {
  return (
        persoX < tailleBordures
    ||  persoY < tailleBordures
    ||  persoX > arrayLaby.length - tailleBordures * 2
    ||  persoY > arrayLaby.length - tailleBordures * 2
  );
}



// Récupérer le contenu texte du labyrinthe
function getLaby() {
  var texteLabyHTML     = $('#idInputLaby');
  texteLaby = $.trim(texteLabyHTML.val());

  if(debug)
    console.log(texteLaby);

  return texteLaby;
}



// Récupérer le contenu texte du parcours
function getParcours() {
  var texteParcoursHTML = $('#idInputParcours');
  texteParcours = $.trim(texteParcoursHTML.val());

  if(debug)
    console.log(texteParcours);

  return texteParcours;
}



// Récupérer la vitesse depuis le text input
function getVitesse() {
  var vitesse = parseInt($('#vitesse').val());

  return Number.isInteger(vitesse)
    ? Math.min(Math.max(vitesse, 50), 5000)
    : 750;
}



// Gère l'affichage de la mort du perso
function manageDeath(arrayLaby) {
  if(isDead(arrayLaby)){
    clearInterval(idInterval);
    persoIcon = iconDeath;
    etatHTML.html('Vous êtes mort :3 / Sortie de labyrinthe');
  }
}



// Calculer le butin max
function maxLoot(texteLaby){
  if(debug)
    console.log(texteLaby);

  var goldCount = (texteLaby.match(/o/g) || []).length;
  var starCount = (texteLaby.match(/\*/g) || []).length;
  butinMax      = goldCount * Math.pow(2, starCount);

  if(debug) {
    console.log('goldCount : '  + goldCount);
    console.log('starCount : '  + starCount);
    console.log('butinMax : '   + butinMax);
  }
}



// Au clic sur le bouton go / Programme principal
function onClickGo(event) {
  // console.log('click');
  etatHTML.html('Parkour en kour..');
  vitesseHTML.attr("disabled", true);

  // Récupérer le contenu texte du labyrinthe
  texteLaby = getLaby();

  // Calculer le butin max
  maxLoot(texteLaby);

  // Récupérer la vitesse de l'utilisateur
  vitesseParkour = getVitesse();

  // Créer une variable js (tableaux lignes/colonnes) représentant le labyrinthe
  labyCurrent = createArrayLaby(texteLaby);
  if(debug)
    console.log(labyCurrent);

  // console.log(checkLabyIntegrity(labyCurrent));
  // Si le labyrinthe est good on reconstruit tout et lance le bouzin
  if(checkLabyIntegrity(labyCurrent)) {
    // Non bloquant, vérifier les caractères du laby
    checkLabyChars(labyCurrent);

    //// Initialiser le personnage (position)
    // Récupérer le contenu texte du parcours
    var texteParcours = getParcours();

    // Annuler l'éventuel précedent parcours non terminé
    clearInterval(idInterval);

    // Réinitialiser le personnage
    texteParcoursCurrent = texteParcours;
    persoX        = 1;
    persoY        = 1;
    butinCurrent  = 0;
    failStarHTML.html('');

    // Générer le labyrinthe en HTML
    updateHTMLLaby(labyCurrent);

    // Dérouler le parcours
    runParkour();
  }
  // Sinon (Laby KO)
  else {
    // Annuler l'éventuel précedent parcours non terminé
    clearInterval(idInterval);

    // Générer le labyrinthe en HTML, afin de faciliter sa création
    updateHTMLLaby(labyCurrent);
  }
}



// Gestion du chargement des labyrinthes fournis
function onClickLabyBtn(event){
  var id = $(this).text() - 1;
  // console.log(id);
  // console.log(labys[id]);

  // Mise à jour des contenus textareas
  texteLabyHTML.val(labys[id]);
  texteParcoursHTML.val(parkours[id]);

  // Ajustement de la vitesse
  vitesseHTML.val( Math.min(Math.max( 750 - 500 * id , 50), 5000) );

  // Déroulé du parcours
  onClickGo();
}



// Gestion du bouton de pause
function onClickPause() {
  // bascule pause/reprise
  if(buttonPauseHTML.html() == 'Pause <i class="fas fa-pause"></i>'){
    clearInterval(idInterval);
    buttonPauseHTML.html('Reprise <i class="fas fa-play"></i>');
    etatHTML.html('Pause <i class="fas fa-pause"></i>');
    vitesseHTML.attr("disabled", false);
  }
  else {
    // Récupérer la vitesse de l'utilisateur
    vitesseParkour = getVitesse();
    vitesseHTML.attr("disabled", true);

    runParkour();
    buttonPauseHTML.html('Pause <i class="fas fa-pause"></i>');
    etatHTML.html('Parkour en kour..');
  }
}



// Mise à jour du labyrinthe HTML, on éclate tout et on refait à partir du tableau
function updateHTMLLaby(arrayLaby){
  var labyrintheHTML = $('.labyrinthe');
  labyrintheHTML.empty();

  var tailleGrille = arrayLaby.length;

  var labyrintheHTMLtext = '';
  labyrintheHTMLtext += ' <table border="1">';
  labyrintheHTMLtext += '   <tbody>';

  // Besoin de la structure sous forme de tableau
  arrayLaby.forEach(function(ligne, indexLigne) {
    labyrintheHTMLtext += '   <tr>';

    ligne.forEach(function(colonne, indexColonne) {
      if(debug)
        console.log(colonne);

      var daClass = '';
      var daUser = '';

      switch(colonne){
        // Gold
        case 'o':
          daClass = iconMoney;
        break;

        // Gold picked up
        case 'op':
          daClass = iconMoney + ' picked';
        break;

        // Star
        case '*':
          daClass = iconStar;
        break;

        // Star picked up
        case '*p':
          daClass = iconStar + ' picked';
        break;

        // User picks up
        case 'x':
          daUser = '<i class="fa-2x fas ' + iconPick + '"></i>';
        break;

        default:

        break;
      }

      if(persoY == indexLigne && persoX == indexColonne)
        daUser = '<i class="fa-2x fas ' + persoIcon + '"></i>';

      labyrintheHTMLtext += '   <td>' + daUser + '<i class="fas ' + daClass + '"></i></td>';
    });

    labyrintheHTMLtext += '   </tr>';
  });

  labyrintheHTMLtext += '   </tbody>';
  labyrintheHTMLtext += ' </table>';

  // Maj du HTML
  labyrintheHTML.html(labyrintheHTMLtext);
}



// Executer la première action et la supprimer de la liste des actions
function runFirstAction(){
  // Récupérer le laby ppour l'actualiser
  var arrayLaby = labyCurrent;

  // Extraire la première action
  var action = extractFirstAction();
  if(debug)
    console.log(action);

  // Réinitialiser l'icône du personnage (enlever le 'pick' de l'action précédente)
  persoIcon = iconRun;

  if(action == '' || action == undefined){
    persoIcon = iconEnd;
    clearInterval(idInterval);
    checkVictory();
  }
  else {
    switch(action) {
      case "^" :
        persoY--;
      break;

      case "v" :
        persoY++;
      break;

      case "<" :
        persoX--;
      break;

      case ">" :
        persoX++;
      break;

      case "x" :
        persoIcon = iconPick;
        arrayLaby = checkPickup(arrayLaby);
      break;


      default :
        alert('Un caractère invalide a été introduit dans le parcours\nLes caractères autorisés sont ^ v < > et x\n \nAttention à ne pas mettre d\'espace, de retour à la ligne ou de majuscule (Je pense à toi "X" è_é)');
        clearInterval(idInterval);
        persoIcon = iconDeath;
        etatHTML.html('Vous êtes mort :3 / Mauvais caractère');
      break;
    }
  }

  // Check for player outside
  manageDeath(arrayLaby);

  updateHTMLLaby(arrayLaby);
}



// Déclenche le parkour au fil du temps
function runParkour() {
  idInterval = setInterval(runFirstAction, vitesseParkour);
}






































//
